import passlib.hash
import time
from cryptacular.bcrypt import BCRYPTPasswordManager
from cryptacular.pbkdf2 import PBKDF2PasswordManager

cr_bcrypt = BCRYPTPasswordManager()
cr_pbkdf = PBKDF2PasswordManager()

ps_bcrypt = passlib.hash.bcrypt
ps_pbkdf = passlib.hash.pbkdf2_sha512

beg1 = time.time()
password = ps_bcrypt.encrypt("test")
print time.time()- beg1

beg2 = time.time()
hashed = cr_bcrypt.encode('test', rounds=12)
print time.time() - beg2

beg3 = time.time()
password = ps_pbkdf.encrypt("test", salt="hola")
print time.time()- beg3

beg4 = time.time()
hashed = cr_pbkdf.encode('test', rounds=12000, salt="hola")
print time.time() - beg4