#import time
import base64
import datetime
import passlib
from passlib.totp import TOTP
import math
import pyotp
import pkg_resources
import platform
import sys

print("version data")
print("platform info: {}".format(platform.platform()))
print("python info: {}".format(sys.version))
print("passlib version: {}".format(passlib.__version__))
print("pyotp version: {}".format(pkg_resources. \
        get_distribution("pyotp").version))
print("")

print("parameters")
allowed_duration_s = 5
allowed_date = datetime.datetime.now()
allowed_date_s = int(allowed_date.strftime("%s"))
num_digits = 6
key = "this is a test"
key_enc = base64.b32encode(bytes(key, encoding='utf-8'))

print("Allowed Duration (s): {}".format(allowed_duration_s))
print("current datetime: " + str(allowed_date))
print("current datetime in s: " + str(allowed_date_s))
print("key_string: \"" + key + "\"")
print("encoded key_string: " + str(key_enc))
print("")

print("passlib setup")
token_base_passlib = TOTP(key = key_enc, \
        period = allowed_duration_s, digits = num_digits)
token_raw_passlib = token_base_passlib.generate(time = allowed_date_s)
print("full token: " + str(token_raw_passlib))
token_passlib = token_raw_passlib.token
print("passlib token-base: {}".format(token_base_passlib))
print("verify passlib token-base duration: {}". \
        format(token_base_passlib.period))
print("passlib token: {}".format(token_passlib))
print("")

print("pyotp setup")
token_base_pyotp = pyotp.TOTP(key_enc, \
        interval=allowed_duration_s, digits=num_digits)
token_pyotp = token_base_pyotp.now()
print("pyotp token-base: {}".format(token_base_pyotp))
print("verify pyotp token-base duration: {}".format(token_base_pyotp.interval))
print("pyotp token: {}".format(token_pyotp))
print("")

#print("unix epoch time (s),time offset (s),result passlib, result pyotp")
test_window = 100
trigger_passlib = 0
trigger_pyotp = 0
for i in range(-math.floor(test_window/2),math.floor(test_window/2)):
    check_time = allowed_date_s + i
    main_string = str(check_time) + "," + str(i)
    res_pyotp = token_base_pyotp. \
            verify(token_pyotp, for_time=check_time)
    if res_pyotp == True and trigger_pyotp == 0:
        print("pyotp switched to true at (unix epoch, offset): " + main_string)
        trigger_pyotp = 1
    if res_pyotp == False and trigger_pyotp == 1:
        print("pyotp switched to true at (unix epoch, offset): " + main_string)
        trigger_pyotp = 2
    try:
        res_passlib = token_base_passlib.match(token_passlib, time=check_time)
        #print(main_string + ",True," + str(res_pyotp))
        if trigger_passlib == 0:
            print("passlib switched to true at (unix epoch, offset): " + main_string)
            trigger_passlib = 1
    except passlib.exc.InvalidTokenError:
        #print(main_string + ",False," + str(res_pyotp))
        if trigger_passlib == 1:
            print("passlib switched to false after true at (unix epoch, offset): " + main_string)
            trigger_passlib = 2
